---Author:  alfalfa6945

Mower.processMowerAreas = Utils.overwrittenFunction(Mower.processMowerAreas, function(self, superFunc, workAreas, numWorkAreas, dropAreas, numDropAreas, remainingWindrowToDrop)
    local pickedUpWindrow = 0
    local numDropAreasUsed = 0
	local totalLitersCut = 0
    for i=1, numWorkAreas do
        local area = workAreas[i]
        local x0 = area.x
        local z0 = area.z
        local x1 = area.x1
        local z1 = area.z1
        local x2 = area.x2
        local z2 = area.z2
		for fruitType, windrowFillType in pairs(FruitUtil.fruitTypeToWindrowFillType) do
			local fruitValue = Utils.getFruitArea(fruitType, x0, z0, x1, z1, x2, z2, true, false)
			if fruitValue > 0 then
				self.currentType = windrowFillType
				local areaPixelsSum, _, sprayFactor, _ = Utils.cutFruitArea(fruitType, x0,z0, x1,z1, x2,z2, true, true)
				if areaPixelsSum > 0 then
					local multi = g_currentMission:getHarvestScaleMultiplier(sprayFactor, 1)
					areaPixelsSum = areaPixelsSum * multi
				end
				local pixelToSqm = g_currentMission:getFruitPixelsToSqm()
				local sqm = areaPixelsSum * pixelToSqm
				local litersChanged = sqm * Utils.getNoNil(FruitUtil.fruitIndexToDesc[fruitType].windrowLiterPerSqm, 1)
				totalLitersCut = totalLitersCut + litersChanged
				if area.dropArea ~= nil then
					dropAreas[area.dropArea].valueAccum = dropAreas[area.dropArea].valueAccum + litersChanged
				else
					if not area.dropWindrow then
						pickedUpWindrow = pickedUpWindrow + litersChanged
					else
						local lx_2 = 0.5*(area.x2 - area.x)
						local lz_2 = 0.5*(area.z2 - area.z)
						local sx = area.x + lx_2
						local sz = area.z + lz_2
						local ex = area.x1 + lx_2
						local ez = area.z1 + lz_2
						local sy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, sx,0,sz)
						local ey = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, ex,0,ez)
						local toDrop = remainingWindrowToDrop + litersChanged
						local dropped, lineOffset = TipUtil.tipToGroundAroundLine(self, toDrop, self.currentType, sx,sy,sz, ex,ey,ez, 0, nil, self.mowerLineOffset, false, nil, false)
						self.mowerLineOffset = lineOffset
						remainingWindrowToDrop = toDrop - dropped
					end
				end
			end
		end
    end
    local unitLength = TipUtil.densityToWorldMap
    for i=1, numDropAreas do
        local area = dropAreas[i]
        local widthX = area.x1 - area.x
        local widthZ = area.z1 - area.z
        local widthLength = Utils.vector2Length(widthX, widthZ)
        local widthLength_2 = 0.5 * widthLength
        local widthX_norm = widthX / widthLength
        local widthZ_norm = widthZ / widthLength
        local middleX = 0.5 * (area.x1 + area.x)
        local middleZ = 0.5 * (area.z1 + area.z)
        local sx = middleX + ( widthX_norm * math.max(0, widthLength_2 - unitLength) )
        local sz = middleZ + ( widthZ_norm * math.max(0, widthLength_2 - unitLength) )
        local ex = middleX - ( widthX_norm * math.max(0, widthLength_2 - unitLength) )
        local ez = middleZ - ( widthZ_norm * math.max(0, widthLength_2 - unitLength) )
        local sy = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, sx,0,sz)
        local ey = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, ex,0,ez)
        local toDrop = area.valueAccum
		local dropped, lineOffset = TipUtil.tipToGroundAroundLine(self, toDrop, self.currentType, sx,sy,sz, ex,ey,ez, 0, nil, area.mowerLineOffset, false, nil, false)
        area.mowerLineOffset = lineOffset
        area.valueAccum = area.valueAccum - dropped
        area.value = dropped
        if dropped > 0 then
            numDropAreasUsed = numDropAreasUsed + 1
        end
    end
	if self.mower.mrUseCuttingDependantPtoPower then
		self.mower.mrCutLitersBuffer = self.mower.mrCutLitersBuffer + totalLitersCut
	end
    return numDropAreasUsed, pickedUpWindrow, remainingWindrowToDrop
end)

Mower.mrProcessMowerAreas = Mower.processMowerAreas